# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from digitaleye_msgs/MGSDefinition.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import digitaleye_msgs.msg
import geometry_msgs.msg

class MGSDefinition(genpy.Message):
  _md5sum = "d8a052c020705bcbfb8599de002a7405"
  _type = "digitaleye_msgs/MGSDefinition"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Boundaries of the Monitored Ground Space
# and Zones

# definition of the MGS boundaries
digitaleye_msgs/Zone mgs

# Definition of the TOLZ(s) boundaries
digitaleye_msgs/Zone[] tolz

# Definition of the TOLZ(s) boundaries
digitaleye_msgs/Zone[] ground

# Definition of the Boarding Zone boundaries
digitaleye_msgs/Zone boarding_zone

================================================================================
MSG: digitaleye_msgs/Zone
# Boundaries of an area managed by the DigitalEye

# Unique identifier of the zone being defined
uint32 zone_id

# list of local coordinates describing the boundaries 
# of the defined zone (meters)
geometry_msgs/Polygon path

# height to which the managed zone extends (meters)
float32 height

================================================================================
MSG: geometry_msgs/Polygon
#A specification of a polygon where the first and last points are assumed to be connected
Point32[] points

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z"""
  __slots__ = ['mgs','tolz','ground','boarding_zone']
  _slot_types = ['digitaleye_msgs/Zone','digitaleye_msgs/Zone[]','digitaleye_msgs/Zone[]','digitaleye_msgs/Zone']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       mgs,tolz,ground,boarding_zone

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MGSDefinition, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.mgs is None:
        self.mgs = digitaleye_msgs.msg.Zone()
      if self.tolz is None:
        self.tolz = []
      if self.ground is None:
        self.ground = []
      if self.boarding_zone is None:
        self.boarding_zone = digitaleye_msgs.msg.Zone()
    else:
      self.mgs = digitaleye_msgs.msg.Zone()
      self.tolz = []
      self.ground = []
      self.boarding_zone = digitaleye_msgs.msg.Zone()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.mgs.zone_id
      buff.write(_get_struct_I().pack(_x))
      length = len(self.mgs.path.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.mgs.path.points:
        _x = val1
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
      _x = self.mgs.height
      buff.write(_get_struct_f().pack(_x))
      length = len(self.tolz)
      buff.write(_struct_I.pack(length))
      for val1 in self.tolz:
        _x = val1.zone_id
        buff.write(_get_struct_I().pack(_x))
        _v1 = val1.path
        length = len(_v1.points)
        buff.write(_struct_I.pack(length))
        for val3 in _v1.points:
          _x = val3
          buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _x = val1.height
        buff.write(_get_struct_f().pack(_x))
      length = len(self.ground)
      buff.write(_struct_I.pack(length))
      for val1 in self.ground:
        _x = val1.zone_id
        buff.write(_get_struct_I().pack(_x))
        _v2 = val1.path
        length = len(_v2.points)
        buff.write(_struct_I.pack(length))
        for val3 in _v2.points:
          _x = val3
          buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _x = val1.height
        buff.write(_get_struct_f().pack(_x))
      _x = self.boarding_zone.zone_id
      buff.write(_get_struct_I().pack(_x))
      length = len(self.boarding_zone.path.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.boarding_zone.path.points:
        _x = val1
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
      _x = self.boarding_zone.height
      buff.write(_get_struct_f().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.mgs is None:
        self.mgs = digitaleye_msgs.msg.Zone()
      if self.tolz is None:
        self.tolz = None
      if self.ground is None:
        self.ground = None
      if self.boarding_zone is None:
        self.boarding_zone = digitaleye_msgs.msg.Zone()
      end = 0
      start = end
      end += 4
      (self.mgs.zone_id,) = _get_struct_I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mgs.path.points = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point32()
        _x = val1
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        self.mgs.path.points.append(val1)
      start = end
      end += 4
      (self.mgs.height,) = _get_struct_f().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.tolz = []
      for i in range(0, length):
        val1 = digitaleye_msgs.msg.Zone()
        start = end
        end += 4
        (val1.zone_id,) = _get_struct_I().unpack(str[start:end])
        _v3 = val1.path
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v3.points = []
        for i in range(0, length):
          val3 = geometry_msgs.msg.Point32()
          _x = val3
          start = end
          end += 12
          (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
          _v3.points.append(val3)
        start = end
        end += 4
        (val1.height,) = _get_struct_f().unpack(str[start:end])
        self.tolz.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.ground = []
      for i in range(0, length):
        val1 = digitaleye_msgs.msg.Zone()
        start = end
        end += 4
        (val1.zone_id,) = _get_struct_I().unpack(str[start:end])
        _v4 = val1.path
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v4.points = []
        for i in range(0, length):
          val3 = geometry_msgs.msg.Point32()
          _x = val3
          start = end
          end += 12
          (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
          _v4.points.append(val3)
        start = end
        end += 4
        (val1.height,) = _get_struct_f().unpack(str[start:end])
        self.ground.append(val1)
      start = end
      end += 4
      (self.boarding_zone.zone_id,) = _get_struct_I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.boarding_zone.path.points = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point32()
        _x = val1
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        self.boarding_zone.path.points.append(val1)
      start = end
      end += 4
      (self.boarding_zone.height,) = _get_struct_f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.mgs.zone_id
      buff.write(_get_struct_I().pack(_x))
      length = len(self.mgs.path.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.mgs.path.points:
        _x = val1
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
      _x = self.mgs.height
      buff.write(_get_struct_f().pack(_x))
      length = len(self.tolz)
      buff.write(_struct_I.pack(length))
      for val1 in self.tolz:
        _x = val1.zone_id
        buff.write(_get_struct_I().pack(_x))
        _v5 = val1.path
        length = len(_v5.points)
        buff.write(_struct_I.pack(length))
        for val3 in _v5.points:
          _x = val3
          buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _x = val1.height
        buff.write(_get_struct_f().pack(_x))
      length = len(self.ground)
      buff.write(_struct_I.pack(length))
      for val1 in self.ground:
        _x = val1.zone_id
        buff.write(_get_struct_I().pack(_x))
        _v6 = val1.path
        length = len(_v6.points)
        buff.write(_struct_I.pack(length))
        for val3 in _v6.points:
          _x = val3
          buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _x = val1.height
        buff.write(_get_struct_f().pack(_x))
      _x = self.boarding_zone.zone_id
      buff.write(_get_struct_I().pack(_x))
      length = len(self.boarding_zone.path.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.boarding_zone.path.points:
        _x = val1
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
      _x = self.boarding_zone.height
      buff.write(_get_struct_f().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.mgs is None:
        self.mgs = digitaleye_msgs.msg.Zone()
      if self.tolz is None:
        self.tolz = None
      if self.ground is None:
        self.ground = None
      if self.boarding_zone is None:
        self.boarding_zone = digitaleye_msgs.msg.Zone()
      end = 0
      start = end
      end += 4
      (self.mgs.zone_id,) = _get_struct_I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mgs.path.points = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point32()
        _x = val1
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        self.mgs.path.points.append(val1)
      start = end
      end += 4
      (self.mgs.height,) = _get_struct_f().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.tolz = []
      for i in range(0, length):
        val1 = digitaleye_msgs.msg.Zone()
        start = end
        end += 4
        (val1.zone_id,) = _get_struct_I().unpack(str[start:end])
        _v7 = val1.path
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v7.points = []
        for i in range(0, length):
          val3 = geometry_msgs.msg.Point32()
          _x = val3
          start = end
          end += 12
          (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
          _v7.points.append(val3)
        start = end
        end += 4
        (val1.height,) = _get_struct_f().unpack(str[start:end])
        self.tolz.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.ground = []
      for i in range(0, length):
        val1 = digitaleye_msgs.msg.Zone()
        start = end
        end += 4
        (val1.zone_id,) = _get_struct_I().unpack(str[start:end])
        _v8 = val1.path
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v8.points = []
        for i in range(0, length):
          val3 = geometry_msgs.msg.Point32()
          _x = val3
          start = end
          end += 12
          (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
          _v8.points.append(val3)
        start = end
        end += 4
        (val1.height,) = _get_struct_f().unpack(str[start:end])
        self.ground.append(val1)
      start = end
      end += 4
      (self.boarding_zone.zone_id,) = _get_struct_I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.boarding_zone.path.points = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point32()
        _x = val1
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        self.boarding_zone.path.points.append(val1)
      start = end
      end += 4
      (self.boarding_zone.height,) = _get_struct_f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3f = None
def _get_struct_3f():
    global _struct_3f
    if _struct_3f is None:
        _struct_3f = struct.Struct("<3f")
    return _struct_3f
_struct_f = None
def _get_struct_f():
    global _struct_f
    if _struct_f is None:
        _struct_f = struct.Struct("<f")
    return _struct_f
